// oh_joyView.h : interface of the COh_joyView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OH_JOYVIEW_H__B33AC7C5_9428_424E_AD53_8E9379E66304__INCLUDED_)
#define AFX_OH_JOYVIEW_H__B33AC7C5_9428_424E_AD53_8E9379E66304__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class COh_joyView : public CScrollView
{
protected:
	unsigned int m_dragging;
	CPoint m_Begin;
	CPoint m_End;
	HCURSOR m_HCross;
	HCURSOR m_HArrows;

protected: // create from serialization only
	COh_joyView();
	DECLARE_DYNCREATE(COh_joyView)

// Attributes
public:
	COh_joyDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COh_joyView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	unsigned int m_Formula_number;
	void new_position(double &x1, double &y1, double a, double b, double c, double d, double e, double f, double sign);
	void Render();
	void loop_simple_render(COh_joyDoc* pDoc,CClientDC* CDC,double &x1,double &y1,int begin,int end,COLORREF color);
	void loop_gradient_render(COh_joyDoc* pDoc,CClientDC* CDC,double &x1,double &y1,
		int begin,int end,COLORREF color1,COLORREF color2);
	void loop_blend_simple_render(COh_joyDoc* pDoc,CClientDC* CDC,double &x1,double &y1,int begin,int end,COLORREF color);
	void loop_blend_gradient_render(COh_joyDoc* pDoc,CClientDC* CDC,double &x1,double &y1,
		int begin,int end,COLORREF color1,COLORREF color2);
	int loop_j;
	int loop_i;
	virtual ~COh_joyView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COh_joyView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnActionsRender();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnActionsRecenter();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int m_Max_x;
	int m_Max_y;
	int m_Delta_x;
	int m_Delta_y;
	BOOL m_Rendered;
	BOOL m_ReCenter;
};

#ifndef _DEBUG  // debug version in oh_joyView.cpp
inline COh_joyDoc* COh_joyView::GetDocument()
   { return (COh_joyDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OH_JOYVIEW_H__B33AC7C5_9428_424E_AD53_8E9379E66304__INCLUDED_)
